program main
!-------------------------------------------------------------------------------
! Programma per testare la struttura lista
!-------------------------------------------------------------------------------
use class_Pila

implicit none

logical           :: Esci,OK
integer           :: ierr,i
real(kind=8)      :: ris
type(Pila)        :: Pila_Expr
type(op_val)      :: elem

! Crea una nuova lista
Pila_Expr = Crea_Pila(100,ierr)
if (ierr .ne. 0) then
   write(*,*) 'Errore allocazione Pila'
   stop
endif

Esci = .False.

do while (.not. Esci)
   write(*,'(a)') 'Scegliere azione:'
   write(*,*)
   write(*,'(a)') '1  ---> Effettuare un PUSH'
   write(*,'(a)') '2  ---> Effettuare un POP'
   write(*,'(a)') '3  ---> Stampare Pila'
   write(*,'(a)') '4  ---> Valutare Pila'
   write(*,'(a)') '10 ---> Uscire'
   write(*,*)
   read(*,*) i
   write(*,*)

   ! Scegli opzione
   select case(i)
      case(1)
         write(*,'(a)') 'Effettuare un PUSH:'
         read(*,*) elem%oper
         if (elem%oper .eq. 'v') read(*,*) elem%val
         OK = Push(elem,Pila_Expr)
         if (.not. OK) then
            write(*,*) 'Errore PUSH, pila piena'
         endif
      case(2)
         write(*,'(a)') 'Effettuare un POP:'
         OK = Pop(elem,Pila_Expr)
         if (.not. OK) then
            write(*,*) 'Errore POP, pila vuota'
         else
            if (elem%oper .eq. 'v') then
               write(*,*) elem%val
            else
               write(*,*) elem%oper
            endif
         endif
         write(*,*)
         write(*,*)
      case(3)
         write(*,'(a)') 'Stampa della PILA:'
         write(*,*)
         call stampa_Pila(Pila_Expr)
         write(*,*)
         write(*,*)
      case(4)
         write(*,'(a)') 'Valuta la PILA:'
         write(*,*)
         ris = Valuta_Pila(Pila_Expr,OK)
         if (OK) then
            write(*,*) 'Il valore dell''espressione e'':',ris
         else
            write(*,*) 'Errore nell''espressione'
         endif
         write(*,*)
         write(*,*)
      case(10)
         ierr = Distruggi_Pila(Pila_Expr)
         if (ierr .ne. 0) then
            write(*,*) 'Errore deallocazione PILA'
         endif
         Esci = .True.
      case default
         write(*,'(a,i3,a)') 'Caso  ',i,' non contemplato!!!!'
         write(*,*)
   end select

enddo

end program main
